Name "Silent SFC:OP Warp Doubling Configuration"

 Page instfiles

OutFile "SilentDoubling.exe"

SilentInstall silent

InstallDirRegKey HKLM "SOFTWARE\Taldren\Starfleet Command Orion Pirates" "Directory"

Section "Install"
StrCmp $0 "disable" Disable_Doubling Enable_doubling

Disable_Doubling:
WriteINIStr "$INSTDIR\sfc.ini"  "Network" "AllowEngineDoubling" "0"
Goto Finished_Doubling_Config

Enable_doubling:
DeleteINIStr "$INSTDIR\sfc.ini"  "Network" "AllowEngineDoubling"

Finished_Doubling_Config:
SectionEnd



 Function .onInit

  Call GetParameters
  Pop $2
  # search for quoted /DOUBLING
  StrCpy $1 '"'
  Push $2
  Push '"/DOUBLING='
  Call StrStr
  Pop $0
  StrCpy $0 $0 "" 1 # skip quote
  StrCmp $0 "" "" next
    # search for non quoted /DOUBLING
    StrCpy $1 ' '
    Push $2
    Push '/DOUBLING='
    Call StrStr
    Pop $0
next:
  StrCmp $0 "" done
    # copy the value after /DOUBLING=
    StrCpy $0 $0 "" 10
  # search for the next parameter
  Push $0
  Push $1
  Call StrStr
  Pop $1
  StrCmp $1 "" done
  StrLen $1 $1
  StrCpy $0 $0 -$1
done:

 FunctionEnd



 Function GetParameters
 
   Push $R0
   Push $R1
   Push $R2
   Push $R3
   
   StrCpy $R2 1
   StrLen $R3 $CMDLINE
   
   ;Check for quote or space
   StrCpy $R0 $CMDLINE $R2
   StrCmp $R0 '"' 0 +3
     StrCpy $R1 '"'
     Goto loop
   StrCpy $R1 " "
   
   loop:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 $R1 get
     StrCmp $R2 $R3 get
     Goto loop
   
   get:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 " " get
     StrCpy $R0 $CMDLINE "" $R2
   
   Pop $R3
   Pop $R2
   Pop $R1
   Exch $R0
 
 FunctionEnd


; StrStr
 ; input, top of stack = string to search for
 ;        top of stack-1 = string to search in
 ; output, top of stack (replaces with the portion of the string remaining)
 ; modifies no other variables.
 ;
 ; Usage:
 ;   Push "this is a long ass string"
 ;   Push "ass"
 ;   Call StrStr
 ;   Pop $R0
 ;  ($R0 at this point is "ass string")

 Function StrStr
   Exch $R1 ; st=haystack,old$R1, $R1=needle
   Exch    ; st=old$R1,haystack
   Exch $R2 ; st=old$R1,old$R2, $R2=haystack
   Push $R3
   Push $R4
   Push $R5
   StrLen $R3 $R1
   StrCpy $R4 0
   ; $R1=needle
   ; $R2=haystack
   ; $R3=len(needle)
   ; $R4=cnt
   ; $R5=tmp
   loop:
     StrCpy $R5 $R2 $R3 $R4
     StrCmp $R5 $R1 done
     StrCmp $R5 "" done
     IntOp $R4 $R4 + 1
     Goto loop
 done:
   StrCpy $R1 $R2 "" $R4
   Pop $R5
   Pop $R4
   Pop $R3
   Pop $R2
   Exch $R1
 FunctionEnd


